// XOR_LED_output_Adruino.ino
// Pico @ IDE 1.8.16

#include <EloquentTinyML.h>
#include <eloquent_tinyml/tensorflow.h>

#include "XOR_model.h"

#define N_INPUTS 2
#define N_OUTPUTS 1
#define TENSOR_ARENA_SIZE 2*1024   // reserved memory space

Eloquent::TinyML::TensorFlow::TensorFlow<N_INPUTS, N_OUTPUTS, TENSOR_ARENA_SIZE> tf;

#define BUTTON1_PIN 21
#define BUTTON2_PIN 22
#define LED_PIN 2
// #define LED_PIN PICO_DEFAULT_LED_PIN

float button1, button2;
float threshold=0.5;

void setup() 
{ Serial.begin(115200); delay(1000);
  tf.begin(XOR_model);
  // check if model load correctly
  if (!tf.isOk()) 
    { Serial.print("ERROR: ");
      Serial.println(tf.getErrorMessage());
      while (true) delay(1000);
    }
    pinMode(LED_PIN, OUTPUT);
}

void loop() 
{ button1 = digitalRead(BUTTON1_PIN);
  button2 = digitalRead(BUTTON2_PIN);
  float input[2] = {button1,button2};
  float predicted = tf.predict(input);
  Serial.print("in1: "); Serial.print(input[0]);
  Serial.print("\t in2: "); Serial.print(input[1]);
  Serial.print("\t predicted: ");
  Serial.println(predicted);
  Serial.println("_________________________________________________");
  if (predicted>threshold) 
    digitalWrite(LED_PIN, HIGH);
  else 
    digitalWrite(LED_PIN, LOW);
  delay(10);
}
