// XOR_emu_Adruino.ino
// Pico @ IDE 1.8.16

#include <EloquentTinyML.h>
#include <eloquent_tinyml/tensorflow.h>

#include "XOR_model.h"

#define N_INPUTS 2
#define N_OUTPUTS 1
#define TENSOR_ARENA_SIZE 2*1024   // reserved memory space

Eloquent::TinyML::TensorFlow::TensorFlow<N_INPUTS, N_OUTPUTS, TENSOR_ARENA_SIZE> tf;

void setup() 
{ Serial.begin(115200); delay(1000);
  tf.begin(XOR_model);
  // check if model load correctly
  if (!tf.isOk()) 
    { Serial.print("ERROR: ");
      Serial.println(tf.getErrorMessage());
      while (true) delay(1000);
    }
}

void loop() 
{ // test for input matrix [(0,0); (0,1); (1,0); (1,1)]
  for (float i=0; i<=1; i++) 
  {for (float j=0; j<=1; j++) 
    { float input[2] = {i,j};
      float predicted = tf.predict(input);
      Serial.print("in1: "); Serial.print(input[0]);
      Serial.print("\t in2: "); Serial.print(input[1]);
      Serial.print("\t predicted: ");
      Serial.println(predicted);
    }
  }
  Serial.println("_________________________________________________");
  delay(10000);
}
